#!/bin/sh
# /home/abacus/C2/danholav.sh - ABACUS operator interface 
# the next line restarts using wish \
exec wish "$0" "$@" -geometry +0+0
########################################################################
#
# BIP ABACUS 
#
# Initial version 980907
# 
# 
########################################################################

Pic copy Pic_bip-feedstor

button $w.p.ti_hem1  -bitmap @./MCH-Konsulting-small-bw-1.xbm \
  -command { change_to bip-menu }
place $w.p.ti_hem1 -x 0 -y 0 

button $w.p.ti_hem2  -bitmap @./MCH-Konsulting-small-bw-2.xbm \
  -command { change_to bip-evaporat }
place $w.p.ti_hem2 -x 48 -y 0 

button $w.p.ti_prev -bitmap @./big_left_button.xbm \
  -command { change_to bip-services }
place $w.p.ti_prev -x 113 -y 0 

button $w.p.ti_next -bitmap @./big_right_button.xbm\
  -command { change_to bip-evaporat }
place $w.p.ti_next -x 148 -y 0

# button $w.p.ti_hem  -bitmap @./Rowan_House.xbm \
#   -command { change_to bip-menu }
# place $w.p.ti_hem -x 0 -y 400 
 
set tags 1

button $w.p.ti_tag -text "No-tags" \
  -command {
      if { $tags } {
	 catch { Pic copy Pic_bip-feedstor-no-tag 
	         $w.p.ti_tag configure -text "tags"
	         set tags 0 }
      } else {
	 catch { Pic copy Pic_bip-feedstor
	         $w.p.ti_tag configure -text "No-tags"
	         set tags 1 }
      }
    }
place $w.p.ti_tag -x 184 -y 0


############## This is the main dynamic data updating proc ##################
#
#
#

set six  15		
set spx 190		
set unx 260		
set rax 325		
set s1x 420		
set s2x 520		

proc update0 {} {
	global w lfont fg bg NODE
	global six spx unx rax s1x s2x

 	global fulltime halftime time_taken
 	
	if { [winfo viewable .] } {

	   set time_taken [ time	{
		get_values
	
## Valves
#### open/close
	catch { shape_2 V43oc  21 179 [vn 10343] valve_onoff_r_open_red-hollow valve_onoff_r_close_green } ;# BIP1:V43.FB.
#### alarm
	catch { if { [vn 10344] } { shape_2_flash V43al  30 184 1 alarm_blob alarm_blob_gray } else { destroy $w.p.tiV43al } }
#### hand/auto
#	catch { shape_2 V43ha 116 339 [vn ] blank hand } ;#   hand/auto

	catch { shape_2 V41oc   61 214 [vn 10337] valve_onoff_r_open_red-hollow valve_onoff_r_close_green } ;# BIP1:V41.FB.
	catch { if { [vn 10339] } { shape_2_flash V41al   70 218 1 alarm_blob alarm_blob_gray } else { destroy $w.p.tiV41al } }
	catch { shape_2 V41ha 91 214 [vn 10338] blank hand } ;#   hand/auto

	catch { shape_2 V42oc   144 195 [vn 10340] valve_onoff_t_open_red-hollow valve_onoff_t_close_green } ;# BIP1:V42.FB.
	catch { if { [vn 10342] } { shape_2_flash V42al   155 185 1 alarm_blob alarm_blob_gray } else { destroy $w.p.tiV42al } }
	catch { shape_2 V42ha 164 195 [vn 10341] blank hand } ;#   hand/auto

	catch { shape_2 V40oc   185 314 [vn 10334] valve_onoff_t_open_red-hollow valve_onoff_t_close_green } ;# BIP1:V40.FB.
	catch { if { [vn 10336] } { shape_2_flash V40al   178 302 1 alarm_blob alarm_blob_gray } else { destroy $w.p.tiV40al } }
	catch { shape_2 V40ha 205 314 [vn 10335] blank hand } ;#   hand/auto

##	catch { shape_4 threeway 177 198 [vn 10113] [vn 10111] bip-three-way-1 bip-three-way-2 bip-three-way-3 bip-three-way-1 }

###--- Infeed Status

	catch { state_text_3 HS013   576 345 [vn 10113] [vn 10114] 0 \
		" OFF " black green	" 15 "  red white	" 14 "  red white " -  " yellow red \
		" OFF " white blue	" 15 "  blue white	" 14 "  blue white " -  " yellow red  }

	catch { state_text_3 HS012   576 359 [vn 10111] [vn 10112] 0 \
		" OFF " black green	" Tank A "  red white	" Tank B "  red white "   -   " yellow red \
		" OFF " white blue	" Tank A "  blue white	" Tank B "  blue white "   -   " yellow red  }

	catch { state_text_2 b10118  521 362 [vn 10118] " Not Feeding " red white  "   FEEDING   " white red } ;# BIP1:IND15.


###--- More valves
	catch { shape_2 V7oc  218 86  [vn 10396] valve_onoff_t_open_red-hollow valve_onoff_t_close_green } ;# (BIP1:V7.FB.)
	catch { if { [vn 10398] } { shape_2_flash V7al   212 74 1 alarm_blob alarm_blob_gray } else { destroy $w.p.tiV7al } }
	catch { shape_2 V7ha 238 86 [vn 10397] blank hand } ;#   hand/auto

	catch { shape_2 V8oc   218 148 [vn 10399] valve_onoff_t_open_red-hollow valve_onoff_t_close_green } ;# (BIP1:V8.FB.)
	catch { if { [vn 10401] } { shape_2_flash V8al   213 136 1 alarm_blob alarm_blob_gray } else { destroy $w.p.tiV8al } }
	catch { shape_2 V8ha 238 148 [vn 10400] blank hand } ;#   hand/auto

	catch { shape_2 V5oc   399 46 [vn 10345] valve_onoff_r_open_red-hollow valve_onoff_r_close_green } ;# (BIP1:V5.FB.)
	catch { if { [vn 10347] } { shape_2_flash V5al   412 50 1 alarm_blob alarm_blob_gray } else { destroy $w.p.tiV5al } }
	catch { shape_2 V5ha 429 46 [vn 10346] blank hand } ;#   hand/auto

	catch { shape_2 V2oc  484 30 [vn 10319] valve_onoff_t_open_red-hollow valve_onoff_t_close_green } ;# (BIP1:V2.FB.)
	catch { if { [vn 10321] } { shape_2_flash V2al   478 20 1 alarm_blob alarm_blob_gray } else { destroy $w.p.tiV2al } }
	catch { shape_2 V2ha 504 30  [vn 10320] blank hand } ;#   hand/auto

	catch { shape_2 V3oc   484 63 [vn 10322] valve_onoff_t_open_red-hollow valve_onoff_t_close_green } ;# (BIP1:V3.FB.)
	catch { if { [vn 10324] } { shape_2_flash V3al   478 53 1 alarm_blob alarm_blob_gray } else { destroy $w.p.tiV3al } }
	catch { shape_2 V3ha 504 63 [vn 10323] blank hand } ;#   hand/auto

	catch { shape_2 V1oc   484 103 [vn 10289] valve_onoff_t_open_red-hollow valve_onoff_t_close_green } ;# (BIP1:V1.FB.)
	catch { if { [vn 10291] } { shape_2_flash V1al   478 93 1 alarm_blob alarm_blob_gray } else { destroy $w.p.tiV1al } }
	catch { shape_2 V1ha 504 103 [vn 10290] blank hand } ;#   hand/auto

	catch { shape_2 V4oc   484 148 [vn 10331] valve_onoff_t_open_red-hollow valve_onoff_t_close_green } ;# (BIP1:V4.FB.)
	catch { if { [vn 10333] } { shape_2_flash V4al   478 138 1 alarm_blob alarm_blob_gray } else { destroy $w.p.tiV4al } }
	catch { shape_2 V4ha 504 148 [vn 10332] blank hand } ;#   hand/auto

	catch { shape_2 V6oc    294 215 [vn 10373] valve_onoff_r_open_red-hollow valve_onoff_r_close_green } ;# (BIP1:V6.FB.)
	catch { if { [vn 10375] } { shape_2_flash al   305 218 1 alarm_blob alarm_blob_gray } else { destroy $w.p.tiV6al } }
	catch { shape_2 V6ha 324 215 [vn 10374] blank hand } ;#   hand/auto

	catch { shape_2 V11oc   340 288  [vn 10295] valve_onoff_t_open_red-hollow valve_onoff_t_close_green } ;# (BIP1:V11.FB.)
	catch { if { [vn 10297] } { shape_2_flash V11al   334 277 1 alarm_blob alarm_blob_gray } else { destroy $w.p.tiV11al } }
	catch { shape_2 V11ha 360 288 [vn 10296] blank hand } ;#   hand/auto

	catch { shape_2 V12oc   386 288 [vn 10298] valve_onoff_t_open_red-hollow valve_onoff_t_close_green } ;# (BIP1:V12.FB.)
	catch { if { [vn 10300] } { shape_2_flash V12al   380 277  1 alarm_blob alarm_blob_gray } else { destroy $w.p.tiV12al } }
	catch { shape_2 V12ha 406 288 [vn 10299] blank hand } ;#   hand/auto

	catch { shape_2 V10oc    494 254 [vn 10292] valve_onoff_t_open_red-hollow valve_onoff_t_close_green } ;# (BIP1:V10.FB.)
	catch { if { [vn 10294] } { shape_2_flash V10al   490 242  1 alarm_blob alarm_blob_gray } else { destroy $w.p.tiV10al } }
	catch { shape_2 V10ha 514 254 [vn 10293] blank hand } ;#   hand/auto

	catch { shape_2 V9oc    454 254 [vn 10402] valve_onoff_t_open_red-hollow valve_onoff_t_close_green } ;# (BIP1:V9.FB.)
	catch { if { [vn 10404] } { shape_2_flash V9al    449 242 1 alarm_blob alarm_blob_gray } else { destroy $w.p.tiV9al } }
	catch { shape_2 V9ha 474 254 [vn 10403] blank hand } ;#   hand/auto

### Pumps
##	catch { shape_2 rs   [vn ] pump_u_green pump_u_red} ;# P40 ??
##	catch { if { [vn ] } { shape_2_flash al  1 alarm_blob alarm_blob_gray } else { destroy $w.p.tial } }
##	catch { shape_2 ha   [vn ] blank hand } ;#   hand/auto

	catch { shape_2 P3rs  249 261  [vn 10185] pump_u_green pump_u_red} ;# (BIP1:P3.FB.)
	catch { if { [vn 10187] } { shape_2_flash P3al  249 261 1 alarm_blob alarm_blob_gray } else { destroy $w.p.tiP3al } }
	catch { shape_2 P3ha   266 274 [vn 10186] blank hand } ;#   hand/auto

	catch { shape_2 P12rs   151 123 [vn 10168] pump_u_green pump_u_red} ;# (BIP1:P12.FB.)
	catch { if { [vn 10170] } { shape_2_flash P12al  151 123 1 alarm_blob alarm_blob_gray } else { destroy $w.p.tiP12al } }
	catch { shape_2 P12ha  164 138  [vn 10169] blank hand } ;#   hand/auto

	catch { shape_2 P20rs  262 28  [vn 10183] pump_r_green pump_r_red} ;# (BIP1:P20.FB.)
	catch { if { [vn 10184] } { shape_2_flash P20al  262 28 1 alarm_blob alarm_blob_gray } else { destroy $w.p.tiP20al } }
#	catch { shape_2 ha   284 16 [vn ] blank hand } ;#   hand/auto

	catch { shape_2 P4rs  560 253  [vn 10188] pump_r_green pump_r_red} ;# (BIP1:P4.FB.)
	catch { if { [vn 10190] } { shape_2_flash P4al  560 254 1 alarm_blob alarm_blob_gray } else { destroy $w.p.tiP4al } }
	catch { shape_2 ha   582 241 [vn 10189] blank hand } ;#   hand/auto

	catch { shape_2 P5rs  560 292  [vn 10191] pump_r_green pump_r_red} ;# (BIP1:P5.FB.)
	catch { if { [vn 10193] } { shape_2_flash P5al 560 292 1 alarm_blob alarm_blob_gray } else { destroy $w.p.tiP5al } }
	catch { shape_2 P5ha   582 279 [vn 10192] blank hand } ;#   hand/auto



### Levels
	catch { text_item LI13val  372 121 "%7.0f l" [ra 10122] } ;# (BIP1:LI13.MV.)
	catch { bar_by_value LI13 [ra 10122]  363 133 450 67 25000 yellow }
	catch { text_item LI14val  372 196 "%7.0f l" [ra 10125] } ;# (BIP1:LI14.MV.)
	catch { bar_by_value LI14 [ra 10125]   362 210 450 67 25000 #9eac3c }
	catch { text_item LI16val   85 94 "%3.0f %%" [ra 10128] } ;# (BIP1:LI16.MV.)
	catch { bar_by_value LI16 [ra 10128]  83 117 118 66 100 #dfa826 }
 
 		}]
	  }

################# Here we queue up this proc again ##########################

##
	show_time $time_taken
	catch { after cancel update0 }
	after $fulltime update0
	}


set bg	#D0D0D0
set bg	grey70
set fg  MidnightBlue
set fg	yellow
set fg	darkgreen
set fg	black
set fg	darkblue
 	
set lfont {courier 10 bold}

update0
update idletasks
###								blk_acb blk_sp blk_hl blk_ll blk_ar blk_st blk_ut
## catch { $w.p.tib6301    configure -command { entry_stuff_multi_ut  8994  0	 0	0      0     0     6301  } }
## catch { $w.p.tib6302    configure -command { entry_stuff_multi_ut  8995  0	 0	0      0     0     6302  } }
## catch { $w.p.tib5307    configure -command { entry_stuff_multi_ut  8992 39022 8992  8992  39022     0       0   } }
## catch { $w.p.tib5307a   configure -command { entry_stuff_multi_ut  8992 39022 8992  8992  39022     0       0   } }
### catch { $w.p.tib5312   configure -command { entry_stuff_multi_ut  8993  0      0      0      0     0       0   } }
## catch { $w.p.tib5304    configure -command { entry_stuff_multi_ut  8991 39021 8991  8991  39021     0       0   } }
## catch { $w.p.tib39021   configure -command { entry_stuff_multi_ut  8991 39021 8991  8991  39021     0       0   } }
## catch { $w.p.tib39021a  configure -command { entry_stuff_multi_ut  8991 39021 8991  8991  39021     0       0   } }
## catch { $w.p.tib6303    configure -command { entry_stuff_multi_ut  8996  0      0      0      0     0     6303  } }

## Pumps
 catch { $w.p.tiP3rs   configure -command { entry_pump_hand_auto_bip  10185 10611 10187 "P3" "PUMP: P3"   } }
 catch { $w.p.tiP3al   configure -command { entry_pump_hand_auto_bip  10185 10611 10187 "P3" "PUMP: P3"   } }

 catch { $w.p.tiP12rs  configure -command { entry_pump_hand_auto_bip  10168 10605 10172 "P12" "PUMP: P12"   } }
 catch { $w.p.tiP12al  configure -command { entry_pump_hand_auto_bip  10168 10605 10172 "P12" "PUMP: P12"   } }

 catch { $w.p.tiP20rs  configure -command { entry_pump_hand_auto_bip  10183 10623 0 "P20" "PUMP: P20"   } }
 catch { $w.p.tiP20al  configure -command { entry_pump_hand_auto_bip  10183 10623 0 "P20" "PUMP: P20"   } }

 catch { $w.p.tiP4rs  configure -command { entry_pump_hand_auto_bip  10188 10624 10189 "P4" "PUMP: P4"   } }
 catch { $w.p.tiP4al  configure -command { entry_pump_hand_auto_bip  10188 10624 10189 "P4" "PUMP: P4"   } }

 catch { $w.p.tiP5rs  configure -command { entry_pump_hand_auto_bip  10191 10625 10192 "P5" "PUMP: P5"   } }
 catch { $w.p.tiP5al  configure -command { entry_pump_hand_auto_bip  10191 10625 10192 "P5" "PUMP: P5"   } }

# catch { $w.p.tiV43oc  configure -command { entry_valve_hand_auto_bip_3 10343 10643 0 "V43"   "VALVE: V43" } }
# catch { $w.p.tiV43al  configure -command { entry_valve_hand_auto_bip_3 10343 10643 0 "V43"   "VALVE: V43" } }
 catch { $w.p.tiV41oc  configure -command { entry_valve_hand_auto_bip_3 10337 10641 10338 "V41"   "VALVE: V41" } }
 catch { $w.p.tiV41al  configure -command { entry_valve_hand_auto_bip_3 10337 10641 10338 "V41"   "VALVE: V41" } }
 catch { $w.p.tiV42oc  configure -command { entry_valve_hand_auto_bip_3 10340 10642 10341 "V42"   "VALVE: V42" } }
 catch { $w.p.tiV42al  configure -command { entry_valve_hand_auto_bip_3 10340 10642 10341 "V42"   "VALVE: V42" } }
 catch { $w.p.tiV40oc  configure -command { entry_valve_hand_auto_bip_3 10334 10640 10335 "V40"   "VALVE: V40" } }
 catch { $w.p.tiV40al  configure -command { entry_valve_hand_auto_bip_3 10334 10640 10335 "V40"   "VALVE: V40" } }
 catch { $w.p.tiV7oc   configure -command { entry_valve_hand_auto_bip_3 10396 10659 10397 "V7"    "VALVE: V7"  } }
 catch { $w.p.tiV7al   configure -command { entry_valve_hand_auto_bip_3 10396 10659 10397 "V7"    "VALVE: V7"  } }
 catch { $w.p.tiV8oc   configure -command { entry_valve_hand_auto_bip_3 10399 10660 10400 "V8"    "VALVE: V8"  } }
 catch { $w.p.tiV8al   configure -command { entry_valve_hand_auto_bip_3 10399 10660 10400 "V8"    "VALVE: V8"  } }
 catch { $w.p.tiV5oc   configure -command { entry_valve_hand_auto_bip_3 10345 10644 10346 "V5"    "VALVE: V5"  } }
 catch { $w.p.tiV5al   configure -command { entry_valve_hand_auto_bip_3 10345 10644 10346 "V5"    "VALVE: V5"  } }
#catch { $w.p.tiV30oc  configure -command { entry_valve_hand_auto_bip_3 10325 10637 10326 "V30" "VALVE: V30"   } }
 catch { $w.p.tiV2oc   configure -command { entry_valve_hand_auto_bip_3 10319 10635 10320 "V2"    "VALVE: V2"  } }
 catch { $w.p.tiV2al   configure -command { entry_valve_hand_auto_bip_3 10319 10635 10320 "V2"    "VALVE: V2"  } }
 catch { $w.p.tiV3oc   configure -command { entry_valve_hand_auto_bip_3 10322 10636 10323 "V3"    "VALVE: V3"  } }
 catch { $w.p.tiV3al   configure -command { entry_valve_hand_auto_bip_3 10322 10636 10323 "V3"    "VALVE: V3"  } }
 catch { $w.p.tiV1oc   configure -command { entry_valve_hand_auto_bip_3 10289 10626 10290 "V1"    "VALVE: V1"  } }
 catch { $w.p.tiV1al   configure -command { entry_valve_hand_auto_bip_3 10289 10626 10290 "V1"    "VALVE: V1"  } }
 catch { $w.p.tiV4oc   configure -command { entry_valve_hand_auto_bip_3 10331 10639 10332 "V4"    "VALVE: V4"  } }
 catch { $w.p.tiV4al   configure -command { entry_valve_hand_auto_bip_3 10331 10639 10332 "V4"    "VALVE: V4"  } }
 catch { $w.p.tiV6oc   configure -command { entry_valve_hand_auto_bip_3 10373 10650 10374 "V6"    "VALVE: V6"  } }
 catch { $w.p.tiV6al   configure -command { entry_valve_hand_auto_bip_3 10373 10650 10374 "V6"    "VALVE: V6"  } }
 catch { $w.p.tiV11oc  configure -command { entry_valve_hand_auto_bip_3 10295 10628 10296 "V11"   "VALVE: V11" } }
 catch { $w.p.tiV11al  configure -command { entry_valve_hand_auto_bip_3 10295 10628 10296 "V11"   "VALVE: V11" } }
 catch { $w.p.tiV12oc  configure -command { entry_valve_hand_auto_bip_3 10298 10629 10299 "V12"   "VALVE: V12" } }
 catch { $w.p.tiV12al  configure -command { entry_valve_hand_auto_bip_3 10298 10629 10299 "V12"   "VALVE: V12" } }
 catch { $w.p.tiV10oc  configure -command { entry_valve_hand_auto_bip_3 10292 10627 10293 "V10"   "VALVE: V10" } }
 catch { $w.p.tiV10al  configure -command { entry_valve_hand_auto_bip_3 10292 10627 10293 "V10"   "VALVE: V10" } }
 catch { $w.p.tiV9oc   configure -command { entry_valve_hand_auto_bip_3 10402 10661 10403 "V9"    "VALVE: V9"  } }
 catch { $w.p.tiV9al   configure -command { entry_valve_hand_auto_bip_3 10402 10661 10403 "V9"    "VALVE: V9"  } }
